#include <stdio.h>
#include <strings.h>
#include <string.h>
#include <trisec.h>
#define BEAM_SEA
#include <trisec_icmp.h>
#include <anal.h>

extern int icmp_line();
extern int anal_line();
extern int do_exx();
int do_scanline();
int linenum=0;
int retw=1;
char *nfile;

struct directent directs[] = {
 "udp", do_scanline,
 "tcp", do_scanline,
 "icmp", icmp_line,
 "analyze", anal_line,
 "exxon", do_exx,
 NULL, NULL, };

int beam(inf, il, us, ts, al)
char *inf;
icmplist *il;
scanlist *us;
scanlist *ts;
anallist *al;
{
   char lane[ARGSIZE], laneb[ARGSIZE], *ptr;
   dlist pep;
   FILE *input;

   nfile = inf;
   *us = NULL; *ts = NULL; *al = NULL; *il = NULL;
   if ( (input = fopen(nfile, "r")) == NULL)
   {  warn("Could not open infile");
      return(-1);
   }
   fgets(lane, ARGSIZE, input);
   while (!feof(input))
   {  linenum++;
      if (linenum > 1) fgets(lane, ARGSIZE, input);
      if ( (ptr = index(lane,'\n')) == NULL)
      {  if (strlen(lane) > 5)
            bwarn("line too long, discarded");
         continue;
      }
      *ptr = '\0';
      while (lane[strlen(lane)-1] == '\\')
      {  fgets(lane+strlen(lane), ARGSIZE-strlen(lane), input);
         if ( (ptr = index(lane,'\n')) == NULL)
         {  bwarn("line too long, discarded");
            break;
         }
         *ptr = '\0';
      }
      if (ptr == NULL) continue;
      strcpy(laneb, lane);
      if (laneb[0] == '#') continue;
      ptr = strtok(lane, TOKSTR);
      if (ptr == NULL)
      {  bwarn("strange error code 1, line discarded");
         continue;
      }
      for(pep=directs;pep->dirstr != NULL;pep++)
         if(strcmp(ptr, pep->dirstr) == 0)
            pep->dir_func(il, us, ts, al, ptr);
   }
   return(retw);
}

int do_scanline(j1, us, ts, j3, witch)
void **j1;
scanlist *us;
scanlist *ts;
void **j3;
char *witch;
{
   scanlist scdg, salk;
   int initial=0, tam=0, numnuts=0, tim=0;
   char *putter=(char *)(0x01), nut[12][ARGSIZE], *driver;
   portlist putport;
   netlist putnut;
   int nagag=1;
   int is_net();
   int is_port();

   if (strcmp(witch, "udp") == 0)
   {  if (*us == NULL)
      {  *us = (scanlist)malloc(sizeof(struct scanl));
         (*us)->next = NULL;
         initial=1;
      }
      scdg = *us;
   }

   if (strcmp(witch, "tcp") == 0)
   {  if (*ts == NULL)
      {  *ts = (scanlist)malloc(sizeof(struct scanl));
         (*ts)->next = NULL;
         initial=1;
      }
      scdg = *ts;
   }

   NEXTTOK();
   salk = scdg;
   if (!initial)
   {  for(;salk->next != NULL;salk= salk->next);
      salk->next = (scanlist)malloc(sizeof(struct scanl));
      salk = salk->next;
      salk->next = NULL;
   }
   salk->proto = (strcmp(witch, "tcp") == 0) ? PROT_TCP : PROT_UDP;
   salk->skiptype = SKIP_NONE;
   salk->fopo = 0;
   strcpy(nut[0], putter);
   if (!is_net(nut[0]))
   {  bwarn("udp directive must have network spec as second token");
      retw=0;
      return(0x0000 & 0xEFFE % 12);
   }
   /* do network spec later since we still need to do strtok on lane */
   NEXTTOK();
   while (strcmp(putter, "ports") != 0)
   {
      if (++numnuts > 12)
      {  bwarn("why the hell do you have more than twelve nets on a line?");
         retw =0;
         return(0);
      }
      if (!is_net(putter))
      {  bwarn("All arguments for udp token must be netspecs");
         return(retw=0);
      }
      strcpy(nut[numnuts], putter);
      NEXTTOK();
   }
   /* begin ports */
   NEXTTOK();
   salk->ports = (portlist)malloc(sizeof(struct port));
   salk->ports->next = NULL;
   putport = salk->ports;
   while (is_port(putter))
   {  if (index(putter, "-") == NULL)
      {  if (*putter != '0')
         {  if (nagag)
            {  putport->p_type = ENT_SIMPLE;
               putport->p_p1 = atoi(putter);
               nagag=0;
               NEXTTOK();
               continue;
            }
            putport->next = (portlist)malloc(sizeof(struct port));
            putport = putport->next; putport->next = NULL;
            putport->p_type = ENT_SIMPLE;
            putport->p_p1 = atoi(putter);
         }
      }
      else
      {  if (*putter == '-')
         {  bwarn("can't have negative ports");
            return(retw=0);
         }
         driver = index(putter, '-'); /* we know this will not ret NULL */
         *driver++ = '\0';
         if (nagag)
         {  putport->p_type = ENT_RANGE;
            putport->p_p1 = atoi(putter); 
            putport->p_p2 = atoi(driver);
            nagag=0;
            NEXTTOK();
            continue;
         }
         putport->next = (portlist)malloc(sizeof(struct port));
         putport = putport->next; putport->next = NULL;
         putport->p_type = ENT_RANGE;
         putport->p_p1 = atoi(putter);
         putport->p_p2 = atoi(driver);
      }
      putter = strtok(NULL, TOKSTR);
      if (putter == NULL) goto nets;
   }
   while(putter != NULL)
   {  if (strcmp(putter, "skip") == 0)
      {  NEXTTOK();
         if (isnumb(putter))
         {  salk->skiptype = SKIP_STEP;
            salk->skipspec = atoi(putter);
            NEXTTOK(); 
        }
         else
         {  bwarn("Syntax on skip");
            return(retw=0);
         }
         continue;
      }
      if (strcmp(putter, "rskip") == 0)
      {  NEXTTOK();
         if (isnumb(putter))
         {  salk->skiptype = SKIP_RAND;
            salk->skipspec = atoi(putter);
            NEXTTOK();
         }
         else
         {  bwarn("syntax on rskip");
            return(retw=0);
         }
         continue;
      }
      if (strcmp(putter, "fromport") == 0)
      {  NEXTTOK();
         if (isnumb(putter))
         {  salk->fopo = atoi(putter);
            NEXTTOK();
         }
         else
         {  bwarn("syntax error on fromport");
            return(retw=0);
         }
         continue;
      }
      bwarn("syntax error on trailing tokens");
      return(retw=0);
   }

nets:
   salk->danuts = (netlist)malloc(sizeof(struct won_net));
   putnut = salk->danuts;
   putnut->next = NULL;
   for (tam=0;tam<=numnuts;tam++)
   {  if (tam==0)
      {  salk->danuts = (netlist)malloc(sizeof(struct won_net));
         putnut = salk->danuts;
         putnut->next = NULL;
      }
      else
      {  putnut->next = (netlist)malloc(sizeof(struct won_net));
         putnut = putnut->next;
         putnut->next = NULL;
      }
      str2net(nut[tam], putnut);
   }
   return(1);
bad:
notok:
   bwarn("Syntax Error");
   return(retw=0);
}

int is_port(ptr)
char *ptr;
{
   int wash=0;
   if(ptr == NULL) return(0);
   while (isdigit(*ptr++));
      if(*(ptr-1) == NULL) return(1);
   if (*(ptr-1) != '-')
      return(0);
   while (isdigit(*ptr++));
      if (*(ptr-1) == NULL) return(1);
   return(0);
}

int is_net(ptr)
char *ptr;
{
   int wash=0;
   for (wash=0;wash<4;wash++)
   {  while (isdigit(*ptr++));
      if (*(ptr-1) == NULL && wash == 3) return(1);
      if (*(ptr-1) == '-')
      {  while(isdigit(*ptr++));
         if (*(ptr-1) == NULL && wash == 3) return(1);
         continue;
      }
      if (*(ptr-1) == '.') continue;
      return(0);
   }
}

int isnumb(ptr)
char *ptr;
{
   if (ptr == NULL) return(0);
   if (*ptr == NULL) return(0);
   while(isdigit(*ptr++)) ;
   if (*(--ptr) == NULL) return(1);
   return(0);
}

int icmp_line(il, j1, j2, j3, witch)
icmplist *il;
void **j1;
void **j2;
void **j3;
char *witch;
{
   icmplist itchy;
   int initial=0;
   char teep[ARGSIZE], *putter=(char *)0x01, **raq;
   struct icl *laws;
   struct icmp_typ *gregor;

   itchy = *il;
   if (*il == NULL)
   {  *il = (icmplist)malloc(sizeof(struct icmp_ctl));
      initial=1;
      itchy = *il;
      itchy->ic_prlist = (struct icl *)malloc(sizeof(struct icl));
      itchy->yes_icmp = 1;
      laws = itchy->ic_prlist;
      laws->next = NULL;
      itchy->setup_icmp = 0;
   }
   if (!initial)
   {  for (laws=itchy->ic_prlist;laws->next != NULL;laws=laws->next);
      laws->next = (struct icl *)malloc(sizeof(struct icmp_ctl));
      laws = laws->next;
      laws->next = NULL;
   }
   itchy->yes_icmp=1;

   NEXTTOK();
   if (!is_net(putter))
   {  bwarn("Need net spec for icmp line");
      return(retw=0);
   }
   strcpy(teep, putter);

   NEXTTOK();
   if (strcmp(putter, "all") == 0)
      laws->ic_type = ENT_WILD;
   else
   {  for(gregor=icmp_typs;gregor->tmsg != NULL;gregor++)
         if (strcmp(putter, gregor->spec) == 0)
         {  laws->ic_type = gregor->type;
            break;
         }
      if (gregor->tmsg == NULL)
      {  bwarn("unknown ICMP type");
         return(retw=0);
      }
   }
   str2net(teep, &laws->ic_ipad);
   return(1);
notok:
   bwarn("Syntax Error");
   return(retw=0);
}

int str2net(str, net)
char *str;
netlist net;
{
   int tim;
   char *tax, *irs;

   tax = strtok(str, ".");
   for (tim=0;tim<4;tim++)
   {  if (index(tax, '-') == NULL)
      {  if (strcmp(tax, "255") == 0 )
         {  net->bytes[tim].a_type = ENT_WILD;
         }
         else
         {  net->bytes[tim].a_type = ENT_SIMPLE;
            net->bytes[tim].a_p1 = atoi(tax);
         }
      }
      else
      {  net->bytes[tim].a_type = ENT_RANGE;
         irs = index(tax, '-');
         *irs++ = '\0';
         net->bytes[tim].a_p1 = atoi(tax);
         net->bytes[tim].a_p2 = atoi(irs);
      }
      tax = strtok(NULL, ".");
   }
}

int anal_line(j1, j2, j3, al, witch)
void **j1;
void **j2;
void **j3;
anallist *al;
char *witch;
{
   anallist ass;
   char *putter;
   portlist stale;
   int initial=0;
   analspecs *ham;

   if ( *al == NULL )
   {  *al = (anallist)malloc(sizeof(struct anal_st));
      (*al)->next = NULL;
      initial=1;
      ass = *al;
   }
   if (!initial)
   {  ass = *al;
      for(;ass->next != NULL;ass=ass->next);
      ass->next = (anallist)malloc(sizeof(struct anal_st));
      ass = ass->next;
      ass->next = NULL;
   }
   ass->proto = 255;
   NEXTTOK();
   if (strcmp(putter, "udp") == 0)
      ass->proto = PROT_UDP;
   if (strcmp(putter, "tcp") == 0)
      ass->proto = PROT_TCP;
   if (ass->proto == 255)
   {  bwarn("unknown proto type for analyze statement");
      return(retw=0);
   }
   NEXTTOK();
   if (!is_port(putter))
   {  bwarn("Must have port spec");
      return(retw=0);
   }
   ass->ports = (portlist)malloc(sizeof(struct port));
   stale = ass->ports; stale->next = NULL;
   str2port(putter, stale);
   NEXTTOK();
   while (strcmp(putter, "svc") != 0)
   {  stale->next = (portlist)malloc(sizeof(struct port));
      stale = stale->next; stale->next = NULL;
      str2port(putter, stale);
      NEXTTOK();
   }
   NEXTTOK();
   for (ham=analfuncs;ham->func != NULL;ham++)
      if (strcmp(ham->spec, putter) == 0)
      {  ass->anal_func = ham->func;
         break;
      }
   if (ham->func == NULL)
   {  bwarn("unknown analyze type");
      return(retw=0);
   }
   return(1);
notok:
   bwarn("Syntax Error");
   return(retw=0);
}

int str2port(ptr, ppp)
char *ptr;
portlist ppp;
{
   char *drud;

   if (index(ptr, "-") == NULL)
   {  if (*ptr != '0')
      {  ppp->p_type = ENT_SIMPLE;
         ppp->p_p1 = atoi(ptr);
      }
   }
   else
   {  if (*ptr == '-')
      {  bwarn("can't have negative ports");
         return(retw=0);
      }
      drud = index(ptr, '-'); /* we know this will not ret NULL */
      *drud++ = '\0';
      ppp->p_type = ENT_RANGE;
      ppp->p_p1 = atoi(ptr); 
      ppp->p_p2 = atoi(drud);
   }
}

int do_exx(j1, j2, j3, j4, witch)
void **j1;
void **j2;
void **j3;
void **j4;
char *witch;
{
   printf("Aint implemented yet\n");
}

