#include <netdb.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/uio.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <signal.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>
#include <fcntl.h> 
#include <trisec.h>

int nicenum=0, killinf=0, killout=0, udpdel=0, tcpdel=0, back=0, kapp=0;
char infile[ARGSIZE], mailto[ARGSIZE], outfile[ARGSIZE],
     smasharg[ARGSIZE], exxon[ARGSIZE];
FILE *ofilep;
int initd=0;
int main(argc, argv)
int argc;
char **argv;
{
   int c; 
   extern int optind; 
   extern char *optarg;
   int keg;
   int usage();
   extern int roll();
   int bam=0;
   scanlist udps, tcps;
   icmplist icmpl;
   anallist anal;

   while ( (c=getopt(argc, argv, "f:m:kbco:s:n:u:t:x:")) != EOF)
      switch (c) {
         case 'f' : strncpy(infile, optarg, ARGSIZE);
                    if (strlen(infile) >= ARGSIZE-1)
                       warn("infile arg overflowed\n");
                    break;
         case 'b' : back=1; break;
         case 'm' : strncpy(mailto, optarg, ARGSIZE);
                    if (strlen(mailto) >= ARGSIZE-1)
                       warn("mailto arg overflowed\n");
                    break;
         case 'k' : killinf=1; break;
         case 'c' : killout=1; break;
         case 'o' : strncpy(outfile, optarg, ARGSIZE);
                    if (strlen(outfile) >= ARGSIZE-1)
                       warn("outfile arg overflowed\n");
                    break;
         case 's' : strncpy(smasharg, optarg, ARGSIZE);
                    if (strlen(smasharg) >= ARGSIZE-1)
                       warn("smasharg arg overflowed\n");
                    break;
         case 'n' : nicenum = atoi(optarg); break;
         case 'u' : udpdel = atoi(optarg); break;
         case 't' : tcpdel = atoi(optarg); break;
         case 'x' : strncpy(exxon, optarg, ARGSIZE);
                    if (strlen(exxon) >= ARGSIZE-1)
                       warn("exxon arg overflow\n");
                    break;
      }

   if ((outfile[0] == 0) || (infile[0] == 0))
      fatal_p(usage);
   if ( (ofilep = fopen(outfile, "w")) == NULL)
      fatal("error opening outfile");

   bam = beam(infile, &icmpl, &udps, &tcps, &anal);
   if (bam == -1)
      fatal("Not continuing, error in beam");
   if (bam == 0)
      warn("could be problems in infile, continuing anyway\n");

   printf("trplie_sec is startin'\n");

   if (smasharg[0] != 0)
   {  printf("smashing argv with \"%s\"\n", smasharg);
      for(optind=0;optind>argc;optind++)
         bzero(argv[optind], strlen(argv[optind]));
      strcpy(argv[0], smasharg);
   }

   if (exxon[0] != 0) printf("will execute \"%s\" on exit\n", exxon);
   if (mailto[0] != 0) printf("check: is %s a valid address?\n", 
                              mailto);
   if (nicenum != 0) {printf("nice\(%d\)\n", nicenum); nice(nicenum); }
   if (udpdel) printf("using a %d millesecond delay for udp stuff\n",
                      udpdel);
   if (tcpdel) printf("using a %d millesecond delay for tcp stuff\n",
                      tcpdel);
   if (killinf) {printf("killing infile\n"); unlink(infile); }
   if (killout) printf("will kill out on exit\n");
   if (killout && mailto[0] == 0)
      warn("-c option specified but -m NOT specificied, continuing any way, all results will get hosed however....\n");
   printf("triple_sec is runnin'\n");
   if (back) 
   {  keg = fork();
      if (keg == -1)
         fatal("could not fork");
      if (keg) 
      {  printf("Backgrounding, pid == %d\n", keg);
         exit(0);
      }
   }

   if (icmpl->yes_icmp) kapp = set_icmp(icmpl);
   skunk_teeceepee(icmpl, tcps, anal);
   skunk_yewdeepee(icmpl, udps, anal);
   /*execl("/bin/sh", 0, 0);*/
   kill(kapp, 9);
}

int usage()
{
   printf("triple_sec v.9b by squarewave\n");
   printf("usage:\n");
   printf("  trisec [-k] [-c] -f infile[.ts] -o outfile [-m address]\
 [-s string]\n");
   printf("         [-n x] [-t tcpdel] [-u udpdel] [-x cmd]\n");
}


int roll(exval)
int exval;
{

   char gah[111];
   sprintf(gah, "Exiting with code %d.", exval);
   output(gah);
   fclose(ofilep);

   if (mailto[0] != 0)
   {  sprintf(gah, "/bin/mail \"%s\" %s < %s\n",
              "Real heros don't use drugs!",
              mailto, outfile);
      system(gah);
   }

   if (killout)  unlink(outfile);
   if (exxon[0] != 0)
   {  strcat(exxon, "\n");
      system(exxon);
   }
   exit(0);
}
