#ifndef TRISEC_AICH
#define TRISEC_AICH

#define ARGSIZE    1024
#define TOKSTR     " :\t"
#define warn(x)      printf("warning: %s\n", x)
#define fatal(x)     roll(printf("fatal: %s\n", x))
#define fatal_p(x)   exit(x())
#define bwarn(x)     printf("%s : %d : %s\n", nfile, linenum, x)

#define NEXTTOK()    if (putter == NULL) goto notok;\
                     if ((putter=strtok(NULL, TOKSTR)) == NULL);

typedef struct directent {
   char *dirstr;                /* token for this directive */
   int (*dir_func)();           /* function to call */
} *dlist;

struct addpart {
   int a_type;                  /* Address part type, simple, range or wild */
   unsigned char a_p1;          /* part one */
   unsigned char a_p2;
};

struct port {
   int p_type;                  /* simple o range */
   unsigned long p_p1;          /* part1 */
   unsigned long p_p2;          /* part2 */
   struct port *next;           /* next */
};
typedef struct port *portlist;

struct won_net {
   struct addpart bytes[4];      /* Four bytes is an address */
   struct won_net *next;
};
typedef struct won_net wonnet;
typedef struct won_net *netlist;
#define ENT_SIMPLE 0x7F         /* Just an address */
#define ENT_RANGE  0x7E         /* Range of addresses */
#define ENT_WILD   0x7D         /* Wildcard */

typedef struct icmp_ctl {
   int yes_icmp;                /* Look for icmp? */
   int setup_icmp;              /* are we initialized? */
   struct icl {                 /* List of what to print */
      wonnet ic_ipad;           /* Host Spec */
      unsigned char ic_type;    /* ICMP type */
      unsigned char ic_stype;   /* SubType */
      struct icl *next;
   } *ic_prlist;
} *icmplist;

#define PROT_UDP 0x01
#define PROT_TCP 0x02

struct anal_st {
   int proto;                   /* UDP o TCP */
   portlist ports;              /* Which ports */
   int (*anal_func)();          /* Analysis func */
   struct anal_st *next;        /* Next Entry */
};
typedef struct anal_st *anallist;

#define SKIP_NONE    0x00
#define SKIP_STEP    0x01
#define SKIP_RAND    0x02

typedef struct scanl {
   int proto;                   /* UDP o TCP */
   unsigned char skiptype;      /* What kind of skip? */
   unsigned int skipspec;       /* How much skip? */
   unsigned long fopo;          /* From what port? */
   netlist danuts;              /* Scan who? */
   portlist ports;              /* Wut pots? */
   struct scanl *next;          /* nuxt */
} *scanlist;

#endif TRISEC_AICH
