#include <sys/types.h>
#include <netinet/in_systm.h>
#include <sys/socket.h>
#include <net/if.h>
#include <netinet/in.h> 
#include <netinet/ip.h>
#include <netinet/if_ether.h> 
#include <netinet/udp.h>

#ifndef	NULL
#define	NULL	0
#endif /* NULL */

#include "dnit.h"

extern Nit	*nit;

short
chksum(buf, nbytes)
  ushort	*buf;
  int		nbytes;
{
  ulong	sum;
  int	nwords;
  
  nwords = nbytes >> 1;
  for(sum=0;nwords>0;nwords--)
    sum += *buf++;
  sum = (sum>>16) + (sum & 0xffff);
  sum += (sum >>16);
  return(~sum);
}

spak(ethsrc, ethdst, ipsrc, ipdst, protocol, data, dlen)
  char	*ethsrc,
	*ethdst;
  char	*ipsrc,
	*ipdst;
  char	*data;
  int	dlen;
{
  char			*buf, *udata;
  struct ether_header	*eh;
  struct ip		iph, *iphp;
  struct udphdr		*udph;
  
  if(dlen & 0x03)
    dlen += 4-(dlen&0x03);
    
  buf	= (char *)malloc(52+dlen);
  if(buf==NULL) return(-1);
  eh	= (struct ether_header *)buf;
  iphp	= (struct ip *) &buf[14];
  udata	= &buf[34];
  
  eh->ether_type = ETHERTYPE_IP; 
  bcopy(ethsrc, &eh->ether_shost, 6);
  bcopy(ethdst, &eh->ether_dhost, 6);

  iph.ip_hl	= 20/4;
  iph.ip_v	= IPVERSION; 
  iph.ip_tos	= 0;
  iph.ip_len	= 20 + (8+dlen);
  iph.ip_id	= 0x1234;
  iph.ip_off	= 0;
  iph.ip_ttl	= 30; 
  iph.ip_p	= protocol;
  iph.ip_sum	= 0;

  bcopy(ipsrc, &iph.ip_src.s_addr, 4);
  bcopy(ipdst, &iph.ip_dst.s_addr, 4);
  
  iph.ip_sum = chksum(iph, 20);
  
  bcopy(&iph, iphp, 20);
  bcopy(data, udata, dlen); 
  NitWrite(nit, buf, 42+dlen);
  free(buf);
}

sudp(ethsrc, ethdst, ipsrc, ipdst, sport, dport, data, dlen)
  ushort	sport, dport;
  char		*data;
  int		dlen;
{
  char		*buf;
  struct udphdr	*udph;
  
  buf = (char *)malloc(16+dlen);

  if(!buf) 
    return(-1);

  udph			= (struct udphdr *)buf;  
  udph->uh_sport	= sport;
  udph->uh_dport	= dport;
  udph->uh_ulen		= 8 + dlen;
  udph->uh_sum		= 0;
  
  bcopy(data, buf+8, dlen);
  spak(ethsrc, ethdst, ipsrc, ipdst, IPPROTO_UDP, buf, dlen+8);
  free(buf);
}
