#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <net/nit_if.h>

#include "dnit.h"
#include "config.h"

char	*dev = 0;
Nit	*nit;

fakeudp(src, dest, data, len)
  struct sockaddr_in	*src, *dest;
  char			*data;
  int			len;
{
  char			*dev=NULL;
  unsigned char		ipadd[4], ethadd[6];
  static struct timeval	timeout = { 1, 0 };

#ifndef	GATE_HOST
  XXX - GATE_HOST not defined!
#endif	/* GATE_HOST */

  if(resolve(GATE_HOST, ipadd) <0 || arp(ipadd, ethadd) <0) {
    fprintf(stderr, "error: cannot find address\n");
    exit(1);
  }

  if((nit=NitOpen((dev)?dev:"le0", 1000000, 0, timeout,
   NI_PROMISC | NI_TIMESTAMP | NI_DROPS | NI_LEN)) == NULL) {
    fprintf(stderr, "error: cannot open device %s\n", (dev)?dev:"le0");
    exit(-1); 
  } 

  sudp(ethadd, ethadd,
   src->sin_addr, dest->sin_addr,
   src->sin_port, dest->sin_port,
   data, len);

  NitClose(nit);
}
