#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define	PORT_ECHOSVC	7

extern char	*dev;

void
usage(name)
  char	*name;
{
  fprintf(stderr, "usage: %s [-d <device>] <dest> <bcast of dest>\n", name);
  exit(-1);
}

void
main(ac, av)
  int	ac;
  char	**av;
{
  char			data[512];
  struct sockaddr_in	from, to;
  char			*progname, *src,
			*dst, dstip[4];
  int			arg, i;
  extern char		*optarg;

  progname = av[0];

  while((arg=getopt(ac, av, "d:")) != EOF) {
    switch(arg) {
    case 'd':
      dev = optarg;
      av++;
      ac--;
      break;
    default:
      usage(progname);
    }
  }

  if(ac!=3) usage(progname);

  dst = av[1];
  src = av[2];

  if(resolve(dst, dstip) <0) {
    fprintf(stderr, "error: cannot resolve %s\n", dst);
    exit(-1);
  }

  for(i=0;i<sizeof(data);i++) {
    data[i]	= 'x';
    data[i++]	= 'X';
  }

  from.sin_family	= AF_INET;
  from.sin_port		= htons(PORT_ECHOSVC);
  from.sin_addr.s_addr	= inet_addr(src);
  /* bcopy(srcip, &from.sin_addr.s_addr, 4); */

  to.sin_family		= AF_INET;
  to.sin_port		= htons(PORT_ECHOSVC);
  to.sin_addr.s_addr	= inet_addr("127.0.0.1");
  bcopy(dstip, &to.sin_addr.s_addr, 4);

  fakeudp(&from, &to, data, strlen(data));
}
