/*
 * Functie ypx_boot(host). Roept de bootparams service aan op host 'host'.
 * Resultaat is een char *. Als er iets mis gaat, return een (char *) 0.
 */
#include <stdio.h>
#include <sys/errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <rpc/rpc.h>
#include <rpcsvc/bootparam.h>
#include "nhost.h"

#ifndef lint
static char *copyright = "@(#)ypx_boot.c 1.1 92/08/22 Rob J. Nauta\n";
#endif

char *programname;
int option;

char *
bootname(host)
char *host;
{
	int stat,i;
	static struct bp_whoami_arg bp_arg, *bp_p;
	static struct bp_whoami_res bp_r, *bp_res=NULL;

	bp_p=&bp_arg;
	bp_arg.client_address.address_type=1;
	bp_arg.client_address.bp_address.ip_addr.net=(char)131;
	bp_arg.client_address.bp_address.ip_addr.host=(char)155;
	bp_arg.client_address.bp_address.ip_addr.lh=(char)70;
	bp_arg.client_address.bp_address.ip_addr.impno=(char)17;
	bp_res=&bp_r;
	bp_r.client_name=malloc(1024);
	bp_r.domain_name=malloc(1024);

	if (stat = callrpc(host, BOOTPARAMPROG, BOOTPARAMVERS,
			   BOOTPARAMPROC_WHOAMI, xdr_bp_whoami_arg, &bp_arg,
			   xdr_bp_whoami_res, bp_res)) {
		clnt_perrno(stat);
		return(NULL);
	}
	/* Print de gevonden gegevens uit */
	return(bp_res->domain_name);
}
